/**
 * version 2.1.5
 * @license
 * =========================================================
 * bootstrap-datetimepicker.js
 * http://www.eyecon.ro/bootstrap-datepicker
 * =========================================================
 * Copyright 2012 Stefan Petre
 *
 * Contributions:
 *  - Andrew Rowls
 *  - Thiago de Arruda
 *  - updated for Bootstrap v3 by Jonathan Peterson @Eonasdan
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =========================================================
 */
(function(c){var b=0,a=function(f,h){var r={pickDate:true,pickTime:true,startDate:moment({y:1970}),endDate:moment().add(50,"y"),collapse:true,language:"en",defaultDate:"",disabledDates:[],icons:{}},J={time:"glyphicon glyphicon-time",date:"glyphicon glyphicon-calendar",up:"glyphicon glyphicon-chevron-up",down:"glyphicon glyphicon-chevron-down"},p=this,D=function(){var N=false,M,O,L;p.options=c.extend({},r,h);p.options.icons=c.extend({},J,p.options.icons);if(!(p.options.pickTime||p.options.pickDate)){throw new Error("Must choose at least one picker")}p.id=b++;moment.lang(p.options.language);p.date=moment();p.element=c(f);p.unset=false;p.isInput=p.element.is("input");p.component=false;if(p.element.hasClass("input-group")){if(p.element.find(".datepickerbutton").size()==0){p.component=p.element.find(".input-group-addon")}else{p.component=p.element.find(".datepickerbutton")}}p.format=p.options.format;L=moment()._lang._longDateFormat;if(!p.format){if(p.isInput){p.format=p.element.data("format")}else{p.format=p.element.find("input").data("format")}if(!p.format){p.format=(p.options.pickDate?L.L:"");p.format+=(p.options.pickTime?" "+L.LT:"")}}p.use24hours=p.format.toLowerCase().indexOf("a")<1;if(p.component){N=p.component.find("span")}if(p.options.pickTime){if(N){N.addClass(p.options.icons.time)}}if(p.options.pickDate){if(N){N.removeClass(p.options.icons.time);N.addClass(p.options.icons.date)}}p.widget=c(H(p.options.pickDate,p.options.pickTime,p.options.collapse)).appendTo("body");p.minViewMode=p.options.minViewMode||p.element.data("date-minviewmode")||0;if(typeof p.minViewMode==="string"){switch(p.minViewMode){case"months":p.minViewMode=1;break;case"years":p.minViewMode=2;break;default:p.minViewMode=0;break}}p.viewMode=p.options.viewMode||p.element.data("date-viewmode")||0;if(typeof p.viewMode==="string"){switch(p.viewMode){case"months":p.viewMode=1;break;case"years":p.viewMode=2;break;default:p.viewMode=0;break}}for(M in p.options.disabledDates){O=p.options.disabledDates[M];O=moment(O);if(!O.isValid()){O=moment(startDate).subtract(1,"day").format("L")}p.options.disabledDates[M]=O.format("L")}p.startViewMode=p.viewMode;p.setStartDate(p.options.startDate||p.element.data("date-startdate"));p.setEndDate(p.options.endDate||p.element.data("date-enddate"));G();K();k();B();m();e();I();if(p.options.defaultDate!==""){p.setValue(p.options.defaultDate)}},n=function(){var L="absolute",N=p.component?p.component.offset():p.element.offset(),M=c(window);p.width=p.component?p.component.outerWidth():p.element.outerWidth();N.top=N.top+p.element.outerHeight();if(p.options.width!==undefined){p.widget.width(p.options.width)}if(p.options.orientation==="left"){p.widget.addClass("left-oriented");N.left=N.left-p.widget.width()+20}if(z()){L="fixed";N.top-=M.scrollTop();N.left-=M.scrollLeft()}if(M.width()<N.left+p.widget.outerWidth()){N.right=M.width()-N.left-p.width;N.left="auto";p.widget.addClass("pull-right")}else{N.right="auto";p.widget.removeClass("pull-right")}p.widget.css({position:L,top:N.top,left:N.left,right:N.right})},y=function(L){p.element.trigger({type:"change.dp",date:p.getDate(),oldDate:L})},v=function(L){p.element.trigger({type:"error.dp",date:L})},m=function(L){moment.lang(p.options.language);var M=L;if(!M){if(p.isInput){M=p.element.val()}else{M=p.element.find("input").val()}if(M){p.date=moment(M)}if(!p.date){p.date=moment()}}p.viewDate=moment(p.date).startOf("month");g();x()},G=function(){moment.lang(p.options.language);var M=moment().weekday(0).weekday(),N=c("<tr>"),L=moment.weekdaysMin();while(M<moment().weekday(0).weekday()+7){N.append('<th class="dow">'+L[(M++)%7]+"</th>")}p.widget.find(".datepicker-days thead").append(N)},K=function(){moment.lang(p.options.language);var M="",L=0,N=moment.monthsShort();while(L<12){M+='<span class="month">'+N[L++]+"</span>"}p.widget.find(".datepicker-months td").append(M)},g=function(){moment.lang(p.options.language);var W=p.viewDate.year(),U=p.viewDate.month(),V=p.options.startDate.year(),Y=p.options.startDate.month(),Z=p.options.endDate.year(),S=p.options.endDate.month(),O,R,Q=[],aa,N,P,X,M,T,L=moment.months();p.widget.find(".datepicker-days").find(".disabled").removeClass("disabled");p.widget.find(".datepicker-months").find(".disabled").removeClass("disabled");p.widget.find(".datepicker-years").find(".disabled").removeClass("disabled");p.widget.find(".datepicker-days th:eq(1)").text(L[U]+" "+W);O=moment(p.viewDate).subtract("months",1);X=O.daysInMonth();O.date(X).startOf("week");if((W==V&&U<=Y)||W<V){p.widget.find(".datepicker-days th:eq(0)").addClass("disabled")}if((W==Z&&U>=S)||W>Z){p.widget.find(".datepicker-days th:eq(2)").addClass("disabled")}R=moment(O).add(42,"d");while(O.isBefore(R)){if(O.weekday()===moment().startOf("week").weekday()){aa=c("<tr>");Q.push(aa)}N="";if(O.year()<W||(O.year()==W&&O.month()<U)){N+=" old"}else{if(O.year()>W||(O.year()==W&&O.month()>U)){N+=" new"}}if(O.isSame(moment({y:p.date.year(),M:p.date.month(),d:p.date.date()}))){N+=" active"}if((moment(O).add(1,"d")<=p.options.startDate)||(O>p.options.endDate)||d(O)){N+=" disabled"}aa.append('<td class="day'+N+'">'+O.date()+"</td>");O.add(1,"d")}p.widget.find(".datepicker-days tbody").empty().append(Q);T=moment().year(),L=p.widget.find(".datepicker-months").find("th:eq(1)").text(W).end().find("span").removeClass("active");if(T===W){L.eq(moment().month()).addClass("active")}if(T-1<V){p.widget.find(".datepicker-months th:eq(0)").addClass("disabled")}if(T+1>Z){p.widget.find(".datepicker-months th:eq(2)").addClass("disabled")}for(P=0;P<12;P++){if((W==V&&Y>P)||(W<V)){c(L[P]).addClass("disabled")}else{if((W==Z&&S<P)||(W>Z)){c(L[P]).addClass("disabled")}}}Q="";W=parseInt(W/10,10)*10;M=p.widget.find(".datepicker-years").find("th:eq(1)").text(W+"-"+(W+9)).end().find("td");p.widget.find(".datepicker-years").find("th").removeClass("disabled");if(V>W){p.widget.find(".datepicker-years").find("th:eq(0)").addClass("disabled")}if(Z<W+9){p.widget.find(".datepicker-years").find("th:eq(2)").addClass("disabled")}W-=1;for(P=-1;P<11;P++){Q+='<span class="year'+(P===-1||P===10?" old":"")+(T===W?" active":"")+((W<V||W>Z)?" disabled":"")+'">'+W+"</span>";W+=1}M.html(Q)},k=function(){moment.lang(p.options.language);var O=p.widget.find(".timepicker .timepicker-hours table"),N="",P,M,L;O.parent().hide();if(p.use24hours){P=0;for(M=0;M<6;M+=1){N+="<tr>";for(L=0;L<4;L+=1){N+='<td class="hour">'+C(P.toString())+"</td>";P++}N+="</tr>"}}else{P=1;for(M=0;M<3;M+=1){N+="<tr>";for(L=0;L<4;L+=1){N+='<td class="hour">'+C(P.toString())+"</td>";P++}N+="</tr>"}}O.html(N)},B=function(){var O=p.widget.find(".timepicker .timepicker-minutes table"),N="",P=0,M,L;O.parent().hide();for(M=0;M<5;M++){N+="<tr>";for(L=0;L<4;L+=1){N+='<td class="minute">'+C(P.toString())+"</td>";P+=3}N+="</tr>"}O.html(N)},x=function(){if(!p.date){return}var N=p.widget.find(".timepicker span[data-time-component]"),L=p.date.hours(),M="AM";if(!p.use24hours){if(L>=12){M="PM"}if(L===0){L=12}else{if(L!=12){L=L%12}}p.widget.find(".timepicker [data-action=togglePeriod]").text(M)}N.filter("[data-time-component=hours]").text(C(L));N.filter("[data-time-component=minutes]").text(C(p.date.minutes()))},A=function(R){R.stopPropagation();R.preventDefault();p.unset=false;var Q=c(R.target).closest("span, td, th"),P,N,O,L,M=p.date;if(Q.length===1){if(!Q.is(".disabled")){switch(Q[0].nodeName.toLowerCase()){case"th":switch(Q[0].className){case"switch":e(1);break;case"prev":case"next":O=F.modes[p.viewMode].navStep;if(Q[0].className==="prev"){O=O*-1}p.viewDate.add(O,F.modes[p.viewMode].navFnc);g();break}break;case"span":if(Q.is(".month")){P=Q.parent().find("span").index(Q);p.viewDate.month(P)}else{N=parseInt(Q.text(),10)||0;p.viewDate.year(N)}if(p.viewMode!==0){p.date=moment({y:p.viewDate.year(),M:p.viewDate.month(),d:p.viewDate.date(),h:p.date.hours(),m:p.date.minutes()});y(M)}e(-1);g();break;case"td":if(Q.is(".day")){L=parseInt(Q.text(),10)||1;P=p.viewDate.month();N=p.viewDate.year();if(Q.is(".old")){if(P===0){P=11;N-=1}else{P-=1}}else{if(Q.is(".new")){if(P==11){P=0;N+=1}else{P+=1}}}p.date=moment({y:N,M:P,d:L,h:p.date.hours(),m:p.date.minutes()});p.viewDate=moment({y:N,M:P,d:Math.min(28,L)});g();w();y(M)}break}}}},q={incrementHours:function(){i("add","hours")},incrementMinutes:function(){i("add","minutes")},decrementHours:function(){i("subtract","hours")},decrementMinutes:function(){i("subtract","minutes")},togglePeriod:function(){var L=p.date.hours();if(L>=12){L-=12}else{L+=12}p.date.hours(L)},showPicker:function(){p.widget.find(".timepicker > div:not(.timepicker-picker)").hide();p.widget.find(".timepicker .timepicker-picker").show()},showHours:function(){p.widget.find(".timepicker .timepicker-picker").hide();p.widget.find(".timepicker .timepicker-hours").show()},showMinutes:function(){p.widget.find(".timepicker .timepicker-picker").hide();p.widget.find(".timepicker .timepicker-minutes").show()},selectHour:function(L){p.date.hours(parseInt(c(L.target).text(),10));q.showPicker.call(p)},selectMinute:function(L){p.date.minutes(parseInt(c(L.target).text(),10));q.showPicker.call(p)}},u=function(N){var M=c(N.currentTarget).data("action"),O=q[M].apply(p,arguments),L=p.date;E(N);if(!p.date){p.date=moment({y:1970})}w();x();y(L);return O},E=function(L){L.stopPropagation();L.preventDefault()},t=function(N){var L=c(N.target),O=moment(L.val()),M=p.date;if(O.isValid()){m();p.setValue(p.date);y(M);w()}else{p.setValue(L.val());y(M);p.unset=true;L.val("")}},e=function(L){if(L){p.viewMode=Math.max(p.minViewMode,Math.min(2,p.viewMode+L))}p.widget.find(".datepicker > div").hide().filter(".datepicker-"+F.modes[p.viewMode].clsName).show()},I=function(){var P,O,M,L,N;p.widget.on("click",".datepicker *",c.proxy(A,this));p.widget.on("click","[data-action]",c.proxy(u,this));p.widget.on("mousedown",c.proxy(E,this));if(p.options.pickDate&&p.options.pickTime){p.widget.on("click.togglePicker",".accordion-toggle",function(Q){Q.stopPropagation();P=c(this);O=P.closest("ul");M=O.find(".in");L=O.find(".collapse:not(.in)");if(M&&M.length){N=M.data("collapse");if(N&&N.transitioning){return}M.collapse("hide");L.collapse("show");P.find("span").toggleClass(p.options.icons.time+" "+p.options.icons.date);p.element.find(".input-group-addon span").toggleClass(p.options.icons.time+" "+p.options.icons.date)}})}if(p.isInput){p.element.on({focus:c.proxy(p.show,this),change:c.proxy(t,this),blur:c.proxy(p.hide,this)})}else{p.element.on({change:c.proxy(t,this)},"input");if(p.component){p.component.on("click",c.proxy(p.show,this))}else{p.element.on("click",c.proxy(p.show,this))}}},o=function(){c(window).on("resize.datetimepicker"+p.id,c.proxy(n,this));if(!p.isInput){c(document).on("mousedown.datetimepicker"+p.id,c.proxy(p.hide,this))}},s=function(){p.widget.off("click",".datepicker *",p.click);p.widget.off("click","[data-action]");p.widget.off("mousedown",p.stopEvent);if(p.options.pickDate&&p.options.pickTime){p.widget.off("click.togglePicker")}if(p.isInput){p.element.off({focus:p.show,change:p.change})}else{p.element.off({change:p.change},"input");if(p.component){p.component.off("click",p.show)}else{p.element.off("click",p.show)}}},j=function(){c(window).off("resize.datetimepicker"+p.id);if(!p.isInput){c(document).off("mousedown.datetimepicker"+p.id)}},z=function(){if(p.element){var M=p.element.parents(),L=false,N;for(N=0;N<M.length;N++){if(c(M[N]).css("position")=="fixed"){L=true;break}}return L}else{return false}},w=function(){moment.lang(p.options.language);var M="",L;if(!p.unset){M=moment(p.date).format(p.format)}if(!p.isInput){if(p.component){L=p.element.find("input");L.val(M)}p.element.data("date",M)}else{p.element.val(M)}if(!p.options.pickTime){p.hide()}},i=function(N,M){moment.lang(p.options.language);var L;if(N=="add"){L=moment(p.date);if(L.hours()==23){L.add(1,M)}L.add(1,M)}else{L=moment(p.date).subtract(1,M)}if(L.isAfter(p.options.endDate)||L.subtract(1,M).isBefore(p.options.startDate)||d(L)){v(L.format(p.format));return}if(N=="add"){p.date.add(1,M)}else{p.date.subtract(1,M)}},d=function(L){moment.lang(p.options.language);var N=p.options.disabledDates,M;for(M in N){if(N[M]==moment(L).format("L")){return true}}return false},C=function(L){L=L.toString();if(L.length>=2){return L}else{return"0"+L}},H=function(M,L,N){if(M&&L){return('<div class="bootstrap-datetimepicker-widget dropdown-menu" style="z-index:9999 !important;"><ul class="list-unstyled"><li'+(N?' class="collapse in"':"")+'><div class="datepicker">'+F.template+'</div></li><li class="picker-switch accordion-toggle"><a class="btn" style="width:100%"><span class="'+p.options.icons.time+'"></span></a></li><li'+(N?' class="collapse"':"")+'><div class="timepicker">'+l.getTemplate()+"</div></li></ul></div>")}else{if(L){return('<div class="bootstrap-datetimepicker-widget dropdown-menu"><div class="timepicker">'+l.getTemplate()+"</div></div>")}else{return('<div class="bootstrap-datetimepicker-widget dropdown-menu"><div class="datepicker">'+F.template+"</div></div>")}}},F={modes:[{clsName:"days",navFnc:"month",navStep:1},{clsName:"months",navFnc:"year",navStep:1},{clsName:"years",navFnc:"year",navStep:10}],headTemplate:'<thead><tr><th class="prev">&lsaquo;</th><th colspan="5" class="switch"></th><th class="next">&rsaquo;</th></tr></thead>',contTemplate:'<tbody><tr><td colspan="7"></td></tr></tbody>'},l={hourTemplate:'<span data-action="showHours" data-time-component="hours" class="timepicker-hour"></span>',minuteTemplate:'<span data-action="showMinutes" data-time-component="minutes" class="timepicker-minute"></span>'};F.template='<div class="datepicker-days"><table class="table-condensed">'+F.headTemplate+'<tbody></tbody></table></div><div class="datepicker-months"><table class="table-condensed">'+F.headTemplate+F.contTemplate+'</table></div><div class="datepicker-years"><table class="table-condensed">'+F.headTemplate+F.contTemplate+"</table></div>";l.getTemplate=function(){return('<div class="timepicker-picker"><table class="table-condensed"><tr><td><a href="#" class="btn" data-action="incrementHours"><span class="'+p.options.icons.up+'"></span></a></td><td class="separator"></td><td><a href="#" class="btn" data-action="incrementMinutes"><span class="'+p.options.icons.up+'"></span></a></td>'+(!p.use24hours?'<td class="separator"></td>':"")+"</tr><tr><td>"+l.hourTemplate+'</td> <td class="separator">:</td><td>'+l.minuteTemplate+"</td> "+(!p.use24hours?'<td class="separator"></td><td><button type="button" class="btn btn-primary" data-action="togglePeriod"></button></td>':"")+'</tr><tr><td><a href="#" class="btn" data-action="decrementHours"><span class="'+p.options.icons.down+'"></span></a></td><td class="separator"></td><td><a href="#" class="btn" data-action="decrementMinutes"><span class="'+p.options.icons.down+'"></span></a></td>'+(!p.use24hours?'<td class="separator"></td>':"")+'</tr></table></div><div class="timepicker-hours" data-action="selectHour"><table class="table-condensed"></table></div><div class="timepicker-minutes" data-action="selectMinute"><table class="table-condensed"></table></div>')};p.destroy=function(){s();j();p.widget.remove();p.element.removeData("DateTimePicker");p.component.removeData("DateTimePicker")};p.show=function(L){p.widget.show();p.height=p.component?p.component.outerHeight():p.element.outerHeight();n();p.element.trigger({type:"show.dp",date:p.date});o();if(L){E(L)}},p.disable=function(){p.element.find("input").prop("disabled",true);s()},p.enable=function(){p.element.find("input").prop("disabled",false);I()},p.hide=function(){var N=p.widget.find(".collapse"),L,M;for(L=0;L<N.length;L++){M=N.eq(L).data("collapse");if(M&&M.transitioning){return}}p.widget.hide();p.viewMode=p.startViewMode;e();p.element.trigger({type:"hide.dp",date:p.date});j()},p.setValue=function(L){moment.lang(p.options.language);if(!L){p.unset=true}else{p.unset=false}var M=moment(L);if(M.isValid()){p.date=M;w();p.viewDate=moment({y:p.date.year(),M:p.date.month()});g();x()}else{v(M)}},p.getDate=function(){if(p.unset){return null}return p.date},p.setDate=function(L){if(!L){p.setValue(null)}else{p.setValue(L)}},p.setEndDate=function(L){p.options.endDate=moment(L);if(!p.options.endDate.isValid()){p.options.endDate=moment().add(50,"y")}if(p.viewDate){m()}},p.setStartDate=function(L){p.options.startDate=moment(L);if(!p.options.startDate.isValid()){p.options.startDate=moment({y:1970})}if(p.viewDate){m()}};D()};c.fn.datetimepicker=function(d){return this.each(function(){var f=c(this),e=f.data("DateTimePicker");if(!e){f.data("DateTimePicker",new a(this,d))}})}})(jQuery);